/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_MODDOCFISC                                               */
/* Tabela : MODDOCFISC                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 23/01/2004 - Newton N. Santos                                              */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_MODDOCFISC
BEFORE INSERT OR UPDATE OR DELETE
ON MODDOCFISC FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUMDFI := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDMODDOCFISC,0) <> NVL(:NEW.CDMODDOCFISC,0)) OR
         (NVL(:OLD.DSMODDOCFISC,0) <> NVL(:NEW.DSMODDOCFISC,0)) THEN
         :NEW.DTULTATUMDFI := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('MODDOCFISC', '', 'CDMODDOCFISC='||:OLD.CDMODDOCFISC||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE MODDOCFISC MODIFY DTULTATUMDFI DEFAULT SYSDATE
/
