/*+
|                                               |
|         Procedure: CONTROLA_CATRACA           |
|                                               |
|            Rotina para seleo de             |
|      digitais de pessoas para a catraca       |
|                                               |
|              Tabela Alterada:                 |
|        PESSOA - Cadastro de Pessoas           |
|                                               |
|     Criao:                                  |
|     Mar/2008 - Danilo dos Anjos Faria         |
|                                               |
+*/


create or replace
PROCEDURE CONTROLA_CATRACA
IS
   V_DTDESLFUNC     DATE NULL;
   V_REGISCATRACA   INTEGER NULL := 0;
   V_COUNTER        INTEGER NOT NULL := 0;
--------------------------------------------------------------------------------
   PROCEDURE REMOVEACESSO(P_NRPESSOA IN PESSOA.NRPESSOA%TYPE) IS        
   BEGIN                                                                
      UPDATE PESSOA                                                     
      SET    IDACESSOCATRACA = 'N'                                      
      WHERE  NRPESSOA = P_NRPESSOA;

      V_COUNTER := V_COUNTER + 1;
      IF (V_COUNTER >= 100) THEN
         BEGIN
            V_COUNTER := 0;
            COMMIT;
         END;
      END IF;
   END;                                                                 
--------------------------------------------------------------------------------
BEGIN 
   FOR C_CATRACA IN(
      SELECT NRPESSOA,        IDTIPOPESSOA,        CDFUNC, 
             CDEMPRESA,       CDFILIAL,            IDACESSOCATRACA
      FROM   PESSOA
      WHERE  IDACESSOCATRACA = 'S'
   )
   LOOP
      IF ((C_CATRACA.IDTIPOPESSOA = 'FUN') AND (LENGTH(C_CATRACA.CDFUNC) > 0) AND (LENGTH(C_CATRACA.CDEMPRESA) > 0)) THEN
         BEGIN
            V_DTDESLFUNC := NULL;         
            SELECT DTDESLFUNC 
            INTO   V_DTDESLFUNC
            FROM   FUNCIONARIO
            WHERE  CDFUNC       =    C_CATRACA.CDFUNC
              AND  CDEMPRESA    =    C_CATRACA.CDEMPRESA;

            IF (V_DTDESLFUNC IS NOT NULL) THEN   
               REMOVEACESSO(C_CATRACA.NRPESSOA);
            END IF;
              
            EXCEPTION                        
               WHEN OTHERS THEN                    
                  V_DTDESLFUNC := NULL;
           
            IF (V_DTDESLFUNC IS NOT NULL) THEN   
               REMOVEACESSO(C_CATRACA.NRPESSOA);
            END IF;
         END;
      ELSE
        BEGIN
           V_REGISCATRACA := NULL;        
           SELECT COUNT(DTREGISCATRACA)
             INTO V_REGISCATRACA
             FROM REGISCATRACA
            WHERE NRPESSOA = C_CATRACA.NRPESSOA
              AND TRUNC(DTREGISCATRACA) >= (TRUNC(SYSDATE) - 30);

            IF (V_REGISCATRACA = 0) THEN   
               REMOVEACESSO(C_CATRACA.NRPESSOA);
            END IF;
         EXCEPTION                        
            WHEN OTHERS THEN                    
                  V_REGISCATRACA := 0;

            IF (V_REGISCATRACA = 0) THEN   
               REMOVEACESSO(C_CATRACA.NRPESSOA);
            END IF;
        END;
      END IF;
   END LOOP;
   COMMIT;   
END; 
/

DECLARE
   V_CDSEQUENCIAL VARCHAR2(20) NULL;
BEGIN
    /*REGISTRANDO A PROCEDURE PARA O AGENDADOR DE EVENTOS*/
    SELECT COUNT(*)
    INTO   V_CDSEQUENCIAL
    FROM   EVENTOAEV 
    WHERE  NMOBJBDEVEN = 'CONTROLA_CATRACA';
    
    IF V_CDSEQUENCIAL = 0 THEN     --> S ADICIONA A PROCEDURE SE ELA NO EXISTIR AINDA NO CADASTRO
        BEGIN
        
            SELECT LPAD(NVL(MAX(LPAD(CDEVENTOAEV, 10, 0))+1,0),10,'0')
            INTO   V_CDSEQUENCIAL
            FROM   EVENTOAEV;
        
            INSERT INTO EVENTOAEV 
            (CDEVENTOAEV, NMEVENTOAEV, IDTPEVENAEV, CDOPERINCL, DTINCLEVEN, NMOBJBDEVEN)
            VALUES
            (V_CDSEQUENCIAL,'Controla BD da Catraca','STP', NULL, SYSDATE, 'CONTROLA_CATRACA');
            COMMIT;
            
        EXCEPTION
           WHEN OTHERS THEN
              RAISE_APPLICATION_ERROR (-20001,'Falha no cadastro de eventos agendveis.');
        END;
    END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ETLRESUFOOD','5.01.018'); END;
/

